#pragma once
#include "PoroMediaDialogShare.h"
#include "ExtrasInput.h"
#include "afxwin.h"

// ExtrasDialog dialog

class ExtrasDialog : public CDialog, public PoroMediaDialogShare
{
	DECLARE_DYNAMIC(ExtrasDialog)

public:
	ExtrasDialog(CWnd* pParent = NULL);   // standard constructor
	virtual ~ExtrasDialog();

// Dialog Data
	enum { IDD = IDD_EXTRASDIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnOK();
	virtual void OnCancel();
	virtual BOOL OnInitDialog();

public:
	CButton check_histogram;
	CButton check_run_resize_to;
	CButton check_debug;
	short field_boundary_erode_short;
	short field_resize_to_wz_short;
	short field_resize_to_wy_short;
	short field_resize_to_wx_short;
	short field_resize_to_mult_short;
	short field_downscale_ratio_short;
	CButton check_run_edge;
	int field_edge_solid_val_int;
	int field_edge_background_int;
	CButton check_run_drawing;
	CButton check_do_not_read_input;

	CButton check_crop_enable;
	int field_crop_z_start_int;
	int field_crop_z_width_int;
	int field_crop_z_end_int;
	int field_crop_y_start_int;
	int field_crop_y_width_int;
	int field_crop_y_end_int;
	int field_crop_x_start_int;
	int field_crop_x_width_int;
	int field_crop_x_end_int;

	//general
	afx_msg void OnBnClickedButtonInputDirectory();
	afx_msg void OnBnClickedButtonWorkDirectory();
	afx_msg void OnCbnSelchangeComboThresholdingMethod();
	afx_msg void OnBnClickedStop();
	afx_msg void OnEnChangeEditWidthSlices();
	afx_msg void OnEnChangeEditEndSlice();
	afx_msg void OnEnChangeEditWidthx();
	afx_msg void OnEnChangeEditEndx();
	afx_msg void OnEnChangeEditWidthy();
	afx_msg void OnEnChangeEditEndy();
	afx_msg void OnEnChangeEditStartSlice();
	afx_msg void OnEnChangeEditStartx();
	afx_msg void OnEnChangeEditStarty();
	afx_msg void OnEnChangeEditManualThreshold();
	//dialog specific
	DECLARE_MESSAGE_MAP()
};
